Switch bootloader from silo to grub-ieee1275 on sparc64

This commit is contained in:
John Paul Adrian Glaubitz 2019-05-09 16:43:26 +02:00
parent a364f3b9d5
commit 3d736a5810
3 changed files with 59 additions and 66 deletions

1
debian/changelog vendored
View File

@ -16,6 +16,7 @@ debian-cd (3.1.24) UNRELEASED; urgency=medium
* Switch bootloader from yaboot to grub-ieee1275 on powerpc
* Switch bootloader from yaboot to grub-ieee1275 on ppc64
* Switch bootloader from silo to grub-ieee1275 on sparc
* Switch bootloader from silo to grub-ieee1275 on sparc64
-- Holger Levsen <holger@debian.org> Wed, 20 Feb 2019 14:12:16 +0100

View File

@ -1,93 +1,86 @@
#!/bin/bash -e
#!/bin/bash
#
# boot-sparc64
# Do install stuff for sparc64, including making bootable CDs
# Works with debian-installer
#
# Do install stuff for sparc64, including making first CD bootable
# $1 is the CD number
# $2 is the temporary CD build dir
. $BASEDIR/tools/boot/$DI_CODENAME/common.sh
set -e
#set -x
N=$1
CDDIR=$2
INSTALLDIR=$CDDIR/install
# Common mkisofs options when creating CDs
add_mkisofs_opt $CDDIR/../$N.mkisofs_opts "-J -joliet-long"
add_mkisofs_opt $CDDIR/../$N.mkisofs_opts "-cache-inodes"
add_mkisofs_opt $CDDIR/../$N.mkisofs_opts "-l"
# mkisofs options specific to sparc64
add_mkisofs_opt $CDDIR/../$N.mkisofs_opts "-G $CDDIR/../CD1/cdboot.img"
add_mkisofs_opt $CDDIR/../$N.mkisofs_opts "-B '...'"
add_mkisofs_opt $CDDIR/../$N.mkisofs_opts "--grub2-sparc-core /boot/grub/core.img"
# Exit if this is not CD#1/DVD#1
if [ $N != "1" ]; then
add_mkisofs_opt $CDDIR/../$N.mkisofs_opts "-J -joliet-long"
add_mkisofs_opt $CDDIR/../$N.mkisofs_opts "-cache-inodes"
add_mkisofs_opt $CDDIR/../$N.mkisofs_opts "-l"
exit 0
fi
if [ "$DI_WWW_HOME" = "default" ]; then
DI_WWW_HOME="https://d-i.debian.org/daily-images/sparc64/daily/cdrom/"
DI_WWW_HOME="https://d-i.debian.org/daily-images/sparc64/daily"
try_di_image_cache
else
DI_WWW_HOME=$(echo $DI_WWW_HOME | sed "s,%ARCH%,$ARCH,")
fi
add_mkisofs_opt $CDDIR/../$N.mkisofs_opts "-G boot1/boot/isofs.b -B ..."
add_mkisofs_opt $CDDIR/../$N.mkisofs_dirs "boot1"
inst=boot1
case "$MKISOFS" in
*xorriso*)
XORRISO_VER=$(xorriso_version)
;;
*)
echo "ERROR: debian-cd now depends on xorriso for making sparc64 bootable CDs."
exit 1;
;;
esac
cd $CDDIR/..
# Setup directories
mkdir -p $inst/boot
BOOT_IMAGES="cdrom/initrd.gz cdrom/vmlinux cdrom/debian-cd_info.tar.gz"
silo_deb=$(find_pkg_file silo)
if [ -z "$silo_deb" ]; then
echo "ERROR: silo package is required"
exit 1
fi
# put the relevant parts of SILO boot loader
(dpkg --fsys-tarfile $MIRROR/$silo_deb | \
tar xf - -C $inst/ ./boot/{isofs,second}.b)
if [ -n "$ARCHIVE_EXTRACTED_SOURCES" ]; then
echo $silo_deb >> $CDDIR/../$N.pkgs_extracted
find_pkg_file silo source >> $CDDIR/../$N.pkgs_extracted
fi
# Some custom etc files
cp -f -p $BASEDIR/data/${CODENAME}/sparc64/silo.conf $inst/boot/
if [ -n "$KERNEL_PARAMS" ]; then
# Add KERNEL_PARAMS to any existing append line
sed -i "/^[[:space:]]*append=\"/ s|append=\"|append=\"$KERNEL_PARAMS |" \
$inst/boot/silo.conf
# If there is no default append= line, add it
if ! grep -q "^append=" $inst/boot/silo.conf; then
sed -i "/^default=/ a\append=\"$KERNEL_PARAMS\"" \
$inst/boot/silo.conf
fi
fi
cat $BASEDIR/data/${CODENAME}/sparc64/debian.txt \
| sed "s/\${MEDIA_TYPE}/CDROM/" \
| sed "s/\${DEBIAN_VERSION}/${CODENAME}/g" \
| sed "s/\${BUILD_DATE}/${BUILD_DATE}/g" \
> $inst/boot/debian.txt
cp $BASEDIR/data/${CODENAME}/sparc64/notsupported.txt $inst/boot/
# Sparc64 kernel is so big, that uncompressing it corrupts SILO memory, so
# uncompress it before hand.
if [ ! "$DI_WWW_HOME" ];then
# Download boot images.
for image in $BOOT_IMAGES; do
if [ ! -e "$image" ]; then
dir=$(dirname $image)
mkdir -p $dir
if [ -n "$LOCAL" -a -f "${LOCALDEBS:-$MIRROR}/dists/$DI_DIST/local/installer-$ARCH/current/images/$image" ]; then
cp "${LOCALDEBS:-$MIRROR}/dists/$DI_DIST/local/installer-$ARCH/current/images/$image" "$image"
elif [ ! "$DI_WWW_HOME" ];then
if [ ! "$DI_DIR" ];then
DI_DIR="$MIRROR/dists/$DI_DIST/main/installer-$ARCH/current/images/cdrom"
DI_DIR="$MIRROR/dists/$DI_DIST/main/installer-$ARCH/current/images"
fi
else
DI_DIR="cdrom"
mkdir "./$DI_DIR"
$WGET "$DI_WWW_HOME" -O ./$DI_DIR/di.dir
sparc64=$(sed -n 's/.*a href="\(vmlinuz-.*-sparc64\)".*/\1/ip' ./$DI_DIR/di.dir)
$WGET "$DI_WWW_HOME/$sparc64" -O ./$DI_DIR/vmlinuz-x-sparc64
$WGET "$DI_WWW_HOME/initrd.gz" -O ./$DI_DIR/initrd.gz
fi
cp "$DI_DIR/$image" "$image"
else
$WGET "$DI_WWW_HOME/$image" -O "$image"
fi
fi
done
if [ ! -e "$DI_DIR"/initrd.gz ] ; then
DI_DIR="$DI_DIR"/cdrom
fi
cp "$DI_DIR"/initrd.gz "$inst/boot/initrd.gz"
#cp "$DI_DIR"/vmlinuz-*-sparc32 "$inst/boot/sparc32"
zcat "$DI_DIR"/vmlinuz-*-sparc64 > "$inst/boot/sparc64"
# Boot setup including config and help files comes from d-i.
mkdir -pv $PWD/CD$N
cat cdrom/debian-cd_info.tar.gz | (cd CD$N/; tar zx)
# Prepend cdboot.img with 512 zero bytes as block 0 contains
# the SUN disk label and would get overwritten by xorriso
dd if=/dev/zero of=$CDDIR/../CD1/cdboot.img bs=512 count=1
dd if=$CDDIR/../CD1/boot/grub/sparc64-ieee1275/cdboot.img of=$CDDIR/../CD1/cdboot.img bs=512 count=1 oflag=append conv=notrunc
# Copy kernel and initrd
mkdir -p $INSTALLDIR
cp -lf cdrom/vmlinux $INSTALLDIR/
cp -lf cdrom/initrd.gz $INSTALLDIR/
exit 0

View File

@ -247,7 +247,6 @@ linux-image-sparc64-smp
initramfs-tools
grub-ieee1275
busybox
silo
linux-image-sparc64
linux-image-sparc64-smp
#endif